﻿var bColsRowsUsed = false;

function ExpandAllTime(sMember){
    var sName = sMember.substr(2,sMember.indexOf("*/")-2);
    var oList = sName.split(",_");
    var sFormula = oList[0];
    if (sFormula=="Trailing" || sFormula=="Previous Trailing"){
        var sLevelName = oList[4];
    }else{
        var sLevelName = oList[1];
    }

    bExpandAllNodes = true;    
    OpenDisplay(oMemberNodes["Date_Formula"]);
    OpenDisplay(oMemberNodes["Date_Formula::" + sLevelName]);
    SelectNode("h" + oMemberNodes[sMember]);
    bExpandAllNodes = false;
}

function OpenDisplay(iDivId){
	if (window.bMultiSelect){
		var o = _("div" + iDivId);
		if (o.style.display=="none") ToggleDisplay(iDivId);
	}else{
		ToggleDisplay(iDivId);
	}	
}

function GetFolderString(sId,sName,iLevel){
	iMemeberId++;
	oExpandedMembers[iMemeberId]= {id: sId, name: sName};
	oMemberNodes[sId] = iMemeberId;
	var sHelp = "";
	if (sId=="Date_Formula") sHelp = "<img width=18 height=11 style='cursor:pointer' src='../images/H.gif' onclick=\"window.open('../help/olap/filterTime.htm')\"/>";
	return "<div class=link ID='folder" + iMemeberId + "' ONCLICK='ToggleDisplay(" + iMemeberId +");' style='margin-left:" + (iLevel*10) + "px'>"
	+ "<IMG SRC='../images/plus.gif' WIDTH=12 HEIGHT=10 ID='btn" + iMemeberId + "' style='margin-top:3px;'>&nbsp;"+ GetLevelCaption(sName) + sHelp + "</div>\n"
	+ "<div style=\"white-space: nowrap; display:none\" ID='div" + iMemeberId + "'></div>";
}

function ExpandDateFormulas(iDivId){
    var oItems = _("div" + iDivId);
    var sLevels = ""
    for(var i=0; i< oLevels.length; i++){
	    var sLevel = oLevels[i][0];	
	    var sDimension = oLevels[i][1];
	    var sLevelName = GetNameFromMember(sLevel);
	    if (sDimension == m_sDimension && NotAllLevel(sLevelName)){
		   sLevels += GetFolderString("Date_Formula::" + sLevelName, sLevelName, 1);
	    }
    }
    oItems.innerHTML = sLevels;
}

function ExpandDateLevel(iDivId){
    var oItems = _("div" + iDivId);
	var sNodeId = oExpandedMembers[iDivId].id;	
    var sLevelName = sNodeId.substr(14);
    oItems.innerHTML = GetDateFormulas(sLevelName);
    return;    
}

function GetDateFormulas(sLevelName){
    if(parent.sDateDimFunc=="custom" && parent.sDateDimFuncCustom!=""){
    	var oMember = GetMember("StrToMember(\""+m_sDimension+"." + parent.sDateDimFuncType + "[\" + " + parent.sDateDimFuncCustom + " + \"]\")");
		if (oMember==null) return "";
	}
    
    bColsRowsUsed = parent.IsColsRowsUsed(m_sDimension);
    
    return GetTimeMemberString("Current",  sLevelName, "", "")
	     + GetTimeMemberString("Previous", sLevelName, "", "")
		 + GetTimeMemberString("Next", sLevelName, "", "")
         + GetLevelsAbove("Parallel", sLevelName)
         + GetLevelsAbove("Parallel2", sLevelName)
         + GetLevelsBoth("Beginning Current", sLevelName)
         + GetLevelsBelow("Beginning Previous", sLevelName, "")
		 + GetLevelsBelow("Beginning Next", sLevelName, "")
         + GetLevelsBelow("Trailing", sLevelName,"")
         + GetLevelsBelow("Previous Trailing", sLevelName,"");
}

function GetLevelsAbove(sFormula, sLName){
    var sRet = "";
    for(var i=0; i< oLevels.length; i++){
	    var sLevel = oLevels[i][0];	
	    var sDimension = oLevels[i][1];
	    var sLevelName = GetNameFromMember(sLevel);
	    if (sDimension == m_sDimension && NotAllLevel(sLevelName)){
		   if (sLevelName == sLName) return sRet;
		   sRet += GetTimeMemberString(sFormula, sLName, sLevelName, "");
	    }
    }
    return sRet;
}

function GetLevelsBelow(sFormula, sLName, sLName2){
    var sRet = "";
    for(var i=oLevels.length-1; i>0; i--){
	    var sLevel = oLevels[i][0];	
	    var sDimension = oLevels[i][1];
	    var sLevelName = GetNameFromMember(sLevel);
	    if (sDimension == m_sDimension && NotAllLevel(sLevelName)){
		   if (sLevelName == sLName) return sRet;
		   sRet += GetTimeMemberString(sFormula, sLevelName, sLName, sLName2);
	    }
    }
    return sRet;
}

function GetLevelsBoth(sFormula, sLName){
    var sRet = "";
    for(var i=0; i< oLevels.length; i++){
	    var sLevel = oLevels[i][0];	
	    var sDimension = oLevels[i][1];
	    var sLevelName = GetNameFromMember(sLevel);
	    if (sDimension == m_sDimension && NotAllLevel(sLevelName)){
		   if (sLevelName == sLName) return sRet;
		   sRet += GetLevelsBelow(sFormula, sLName, sLevelName);
	    }
    }
    return sRet;
}

function NotAllLevel(s){
	if (s=="(All)") return false;
	if (s=="(Todos)") return false;
	return true;
}

function GetCurrentMember(sLevel){
	var sDateDimPos = parent.sDateDimPos;
	
	switch(parent.sDateDimFunc){
		case "lastMeasure": return "Tail(NonEmptyCrossJoin("+sLevel+".Members,{"+parent.GetMeasuresList()+"}),"+sDateDimPos+").Item(0).Item(0)";
		case "lastCalc": return "Tail(CrossJoin("+sLevel+".Members,{"+parent.GetMeasuresList()+"}),"+sDateDimPos+").Item(0).Item(0)";
		case "lastSel": return "Tail(NonEmptyCrossJoin("+sLevel+".Members,{"+parent.GetSelMeasures()+"}),"+sDateDimPos+").Item(0).Item(0)";
		case "custom": if (parent.sDateDimFuncCustom!="") return "Ancestor(StrToMember(\""+m_sDimension+"." + parent.sDateDimFuncType + "[\" + " + parent.sDateDimFuncCustom + " + \"]\"),"+sLevel+")";
	}
	return "Tail("+sLevel+".Members,"+sDateDimPos+").Item(0)";
}

function GetTimeMemberString(sFormula, sLevelName, sParentLevelName, sLevelName2) {

	if ((sFormula == "Next" || sFormula == "Beginning Next") && parent.sDateDimFunc != "custom") {
		return "";
	}

	iMemeberId++;
	var sLevel = m_sDimension + ".["+sLevelName+"]";
	var sParentLevel = m_sDimension+".["+sParentLevelName+"]";
	var sCurrentMember = GetCurrentMember(sLevel);	
    
    if (sFormula=="Trailing" || sFormula=="Previous Trailing"){
	    var sParCurMember = GetCurrentMember(sParentLevel) + ".PrevMember";
	    var sUnits = GetCalcMember("COUNT(Descendants("+sParCurMember+","+sLevel+"))");
	    var sLabel = sFormula+",_"+sUnits+",_"+sLevelName+",_(s),_"+sParentLevelName;
        var sMemberMdx = "/*"+sLabel+"*/"+m_sDimension+".["+sLabel.split(",_").join(" ")+"]";
        if (sFormula=="Trailing"){
            var sMemberMdx1 = sCurrentMember+".Lag("+sUnits+"-1)";
            var sMemberMdx2 = sCurrentMember;        
        }else{
            var sMemberMdx1 = sCurrentMember+".Lag("+sUnits+"*2-1)";
            var sMemberMdx2 = sCurrentMember+".Lag("+sUnits+")";
        }
    }else if (sFormula=="Beginning Current"){
        var sYearLevel = m_sDimension+".["+sLevelName2+"]";
	    var sLabel = sFormula+",_"+sParentLevelName+",_previous,_"+sLevelName2+",_until matching current,_"+sLevelName;
        var sMemberMdx = "/*"+sLabel+"*/"+m_sDimension+".["+sLabel.split(",_").join(" ")+"]";
        var sMemberMdx2 = "ParallelPeriod("+sYearLevel+",1,"+sCurrentMember+")";
        var sMemberMdx1 = "Head(PeriodsToDate("+sParentLevel+","+sMemberMdx2+"),1).Item(0)";
        
    }else if (sFormula=="Beginning Previous"){
	    var sLabel = sFormula+",_"+sParentLevelName+",_until matching current,_"+sLevelName;
        var sMemberMdx = "/*"+sLabel+"*/"+m_sDimension+".["+sLabel.split(",_").join(" ")+"]";
        var sMemberMdx2 = "ParallelPeriod("+sParentLevel+",1,"+sCurrentMember+")";
        var sMemberMdx1 = "Head(PeriodsToDate(" + sParentLevel + "," + sMemberMdx2 + "),1).Item(0)";

	} else if (sFormula == "Beginning Next") {
       	var sLabel = sFormula + ",_" + sParentLevelName + ",_until matching next,_" + sLevelName;
       	var sMemberMdx = "/*" + sLabel + "*/" + m_sDimension + ".[" + sLabel.split(",_").join(" ") + "]";
       	var sMemberMdx2 = "ParallelPeriod(" + sParentLevel + ",-1," + sCurrentMember + ")";
       	var sMemberMdx1 = "Head(PeriodsToDate(" + sParentLevel + "," + sMemberMdx2 + "),1).Item(0)";

    }else if (sFormula=="Parallel"){
	    var sLabel = "Current,_"+sLevelName+",_previous,_"+sParentLevelName;
        var sMemberMdx = "/*"+sLabel+"*/ParallelPeriod("+sParentLevel+",1,"+sCurrentMember+")";
    }else if (sFormula=="Parallel2"){
	    var sLabel = "Previous,_"+sLevelName+",_previous,_"+sParentLevelName;
        var sMemberMdx = "/*"+sLabel+"*/ParallelPeriod("+sParentLevel+",1,"+sCurrentMember+").PrevMember";
    }else{
        var sLabel = sFormula+",_"+sLevelName;
        var sMemberMdx = "/*"+sLabel+"*/" + sCurrentMember;
        if (sFormula == "Previous") {
        	sMemberMdx += ".PrevMember";
        }else if (sFormula == "Next"){
        	sMemberMdx += ".NextMember";
		}
    }
    
    if (sFormula == "Beginning Previous" || sFormula == "Trailing" || sFormula == "Previous Trailing" || sFormula == "Beginning Current" || sFormula == "Beginning Next") {
        var sName = GetMemberName(sMemberMdx1) + " - " + GetMemberName(sMemberMdx2);
        if (bColsRowsUsed) sMemberMdx = "/*"+sLabel+"*/" + sMemberMdx1 + " : " + sMemberMdx2;
    }else{
        var sName = GetMemberName(sMemberMdx);
    }
    
    var oLabel = sLabel.split(",_");
    if (sFormula!="Beginning Current") oLabel.length=4;
    
    var sLabel2 = "";
    for(var i=0; i<oLabel.length; i++){
		if (oLabel[i]){
			if (sLabel2!="") sLabel2 += " ";
			sLabel2 += PadLabel(oLabel[i]);
		}
    }
    
    sName = sLabel2 + " (" + sName + ")";
	oExpandedMembers[iMemeberId]= {id:sMemberMdx, name: sName};
    oMemberNodes[sMemberMdx] = iMemeberId;
    
	if (bMultiSelect){
		var sChecked = "";
		var oMultiMembers = GetMultiMembers();
		if (oMultiMembers[sMemberMdx]){sChecked = " checked "};
		var sAnc = "&nbsp;<INPUT type=checkbox name=ckb" + iMemeberId + " id=ckb" + iMemeberId + sChecked + " onclick='SelectMultiMember(" + iMemeberId + ",event)'>&nbsp;<label id=lbl" + iMemeberId + " class=MultiLink for=ckb" + iMemeberId + ">"+ sName + "</label><br>\n";
	}else{
		var sAnc = "&nbsp;<span id=h" + iMemeberId + " class='link hand' onclick='SelectMember(" + iMemeberId + ",event)'>"+ sName + "</span><br>\n";
	}	
	
	return "<div ONCLICK='ToggleDisplay(" + iMemeberId +");' style='margin-left:24px'>" + sAnc + "</div>\n";
}

function PadLabel(s){
	if (s=="Current") return oLabels[1070];
	if (s == "Previous" || s == "previous") return oLabels[1071];
	if (s == "Next") return oLabels[1211];
	if (s=="Trailing") return oLabels[1072];
	if (s=="Previous Trailing") return oLabels[1073];
	if (s == "until matching current") return oLabels[1074];
	if (s == "until matching next") return "until matching next";
	if (s=="Beginning Current") return oLabels[1075];
	if (s=="Beginning Previous") return oLabels[1076];

	return GetLevelCaption(s);
}

function GetLevelCaption(s){
    for(var i=0; i< oLevels.length; i++){
	    if (oLevels[i][0] == m_sDimension + ".["+s+"]") return oLevels[i][3];
    }
    return s;
}

function GetCalcMember(sMember){
	var sMdx = "with member [Measures].[Test] AS '"+sMember+"' select {[Measures].[Test]} on columns from ["+sCube+"]";
	var oXmla = new Xmla;
	var oDoc = oXmla.Execute(sMdx);
	var oNodes = SelectNodes(oDoc, "//root/CellData/Cell");
	if (oNodes.length==0) return "00";
	return GetXmlNodeText(oNodes[0], "Value");
}

